<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – rrdproxy</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="rrdproxy">rrdproxy</h1>
<p>Cacti RRD Proxy is a standalone proxy interface to Tobi Oetiker's great RRDtool.</p>
<p>The main focus of this project is to allow the relocation of RRDfiles, data replication, support of Cacti Boost and, if needed, the RRDcached daemon. It allows system administrators to split Cacti's access resources across machines without the need for NFS.</p>
<p>Due the fact that updates to files may contain sensitive data and to prevent undesired updates, RRDtool proxy utilitizes high encrypted connections (RSA2048 and AES192) with continuously changing keys. This ensures a secured connection between the proxy and registered clients and/or other proxies.</p>
<p>A local service port is provided to allow administrators are able to access a separate command line interface which provides easy access to configure and debug the proxy.</p>
<h2 id="contribute">Contribute</h2>
<p>Get involved in development by participating in active development on <a href="https://github.com/Cacti/rrdproxy/">GitHub</a>.</p>
<h2 id="requirements">Requirements</h2>
<p>RRDproxy runs on any Unix-based operating system that can meet the minimum requirements, though it will perform better with the recommended (or higher).</p>
<h3 id="minimum-requirements">Minimum Requirements</h3>
<ul>
<li><p>PHP Version 7.1 or higher Installation must include and enable the following modules:</p>
<ul>
<li><p>Sockets</p></li>
<li><p>Posix</p></li>
<li><p>PCntl</p></li>
<li><p>GMP</p></li>
<li><p>ZLIB</p></li>
</ul></li>
<li><p>RRDtool Version 1.5 or higher</p></li>
<li><p>Cacti Version 1.2.7 or higher</p></li>
</ul>
<h3 id="recommended-requirements">Recommended Requirements</h3>
<p>All minimum requirements must be met, though the following are more optinal:</p>
<ul>
<li><p>PHP Version 7.3 or higher Include all minimum recommendation modules</p></li>
<li><p>RRDtool 1.7 or higher</p></li>
<li><p>Cacti 1.2.7</p></li>
</ul>
<h2 id="usage">Usage</h2>
<p>Before using the RRDproxy, you must install the system using the setup wizard which can be run at any point using the -w parameter.</p>
<pre class="shell"><code> php rrdtool-proxy.php --help

 RRDtool Proxy v1.2.7
 Copyright (C) 2004-2021 The Cacti Group
 usage: rrdtool-proxy.php [--wizard] [-w] [--version] [-v]
 Optional:
 -v --version   - Display this help message
 -w --wizard    - Start Configuration Wizard
</code></pre>
<p>When running through the wizard, the status of items will appear on the right hand side of the screen. When an item is successfully completed, the status of <code>[OK]</code> will be shown in green (when color is supported) as seen below:</p>
<pre class="shell"><code>Checking System Requirements...
[0.00001] test: operation system supported                                  [OK]
[0.00007] test: php module &#39;sockets&#39;                                        [OK]
[0.00011] test: php module &#39;posix&#39;                                          [OK]
</code></pre>
<p>Should any item have an issue, the status will be displayed as something other than <code>[OK]</code> such as <code>[FAILED]</code>:</p>
<pre class="shell"><code>[0.40270] read: RRDproxy configuration file                             [FAILED]
</code></pre>
<p>Status Color | Description : --- | : --- Green | Success and without issue Yellow | Warnings and will be ignored, correct the problem if needed Red | Errors and will not be ignored, may prevent continuation</p>
<p>When the wziard prompts for the various settings that are available, you can accept the default value simply by pressing return to accept it. Below are a few of these settings and the default values that can be accepted:</p>
<p>Setting | Default | Comment : --- | : --- | : --- CLI System Prompt | rrdp | Max 8 chars IPv4 Listen Addr | 0.0.0.0 | Listen all addr Client Proxy Port | 40301 | Connections from a client Proxy Proxy port | 40302 | Connections from another proxy Dedicated CLI port | 40303 | Connections to the RRDproxy cli</p>
<h2 id="command-line-interface">Command Line Interface</h2>
<p>Use '?' to get a list of all commands being supported by the proxy or hints about missing parameters.</p>
<pre class="console"><code>telnet localhost 40303
Trying 127.0.0.1...
Connected to localhost.
Escape character is &#39;^]&#39;.
rrdp&gt;?
  enable          Turn on privileged commands
  help            Display help
  show            Show running system information
  quit            Close terminal session

rrdp&gt;ena
rrdp#sh version

#     ___           _   _     __    __    ___     ___
#    / __\__ _  ___| |_(_)   /__\  /__\  /   \   / _ \_ __ _____  ___   _
#   / /  / _` |/ __| __| |  / \// / \// / /\ /  / /_)/ &#39;__/ _ \ \/ / | | |
#  / /__| (_| | (__| |_| | / _  \/ _  \/ /_//  / ___/| | | (_) &gt;  &lt;| |_| |
#  \____/\__,_|\___|\__|_| \/ \_/\/ \_/___,&#39;   \/    |_|  \___/_/\_\__, |
#                                                                   |___/

 RRDtool Proxy v1.2.7
 Copyright (C) 2004-2021 The Cacti Group
 rrdp uptime is 14 days, 0 hours, 4 minutes, 14 seconds
 Memory usage 0.18872917 % (2026464/1073741824 in bytes)
 a8:29:6a:b7:5d:be:c3:8a:be:13:7a:61:ee:0c:8b:d3
 Process ID: 13996
 Session usage (1/399)

 Server IP [192.168.10.10]
 Administration: [localhost       :40303]
 Replication:    [192.168.10.10   :40302]
 Clients:        [192.168.10.10   :40301]

rrdp#
</code></pre>
<h2 id="missing-features">Missing features</h2>
<ul>
<li><p>Data replication has been completed to 95%, but is still not ready</p></li>
<li><p>NET-SNMP pass persistent daemon and MIB needs to written to make proxy stats available through SNMP</p></li>
</ul>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
